=== modified file 'www/apps/tutorial/__init__.py'
--- www/apps/tutorial/__init__.py	2008-03-15 07:51:53 +0000
+++ www/apps/tutorial/__init__.py	2008-03-15 09:00:15 +0000
@@ -356,11 +356,17 @@
     req.write("<p><b>Exercise:</b> %s</p>\n" % exercisename)
     if exercisedesc is not None:
         req.write("<div>%s</div>\n" % exercisedesc)
-    req.write('<textarea class="exercisebox" cols="80" rows="%s">%s</textarea>'
-            % (rows, exercisepartial))
     filename = cgi.escape(cjson.encode(exercisesrc), quote=True)
+    req.write('<textarea class="exercisebox" '
+        'onkeypress="set_saved_status(&quot;exercise%s&quot;, %s, '
+            '&quot;Save&quot;)" '
+        'onchange="set_saved_status(&quot;exercise%s&quot;, %s, '
+            '&quot;Save&quot;)" '
+        'cols="80" rows="%s">%s</textarea>'
+        % (exerciseid, filename, exerciseid, filename, rows, exercisepartial))
     req.write("""\n<div class="exercisebuttons">
-  <input type="button" value="Save"
+  <input type="button" value="Saved" disabled="disabled"
+    id="savebutton_exercise%d"
     onclick="saveexercise(&quot;exercise%d&quot;, %s)"
     title="Save your solution to this exercise" />
   <input type="button" value="Run"
@@ -372,5 +378,6 @@
 </div>
 <div class="testoutput">
 </div>
-""" % (exerciseid, filename, exerciseid, filename, exerciseid, filename))
+""" % (exerciseid, exerciseid, filename, exerciseid, filename,
+       exerciseid, filename))
     req.write("</div>\n")

=== modified file 'www/media/tutorial/tutorial.js'
--- www/media/tutorial/tutorial.js	2008-03-15 05:55:20 +0000
+++ www/media/tutorial/tutorial.js	2008-03-15 09:00:15 +0000
@@ -88,6 +88,7 @@
  */
 function saveexercise(exerciseid, filename)
 {
+    set_saved_status(exerciseid, filename, "Saving...");
     /* Get the source code the student is submitting */
     var exercisediv = document.getElementById(exerciseid);
     var exercisebox = exercisediv.getElementsByTagName("textarea")[0];
@@ -101,11 +102,56 @@
     var callback = function(xhr)
         {
             // XXX Maybe check to see if this worked?
+            set_saved_status(exerciseid, filename, "Saved");
         }
     ajax_call(callback, "tutorialservice", "", args, "POST",
         "multipart/form-data");
 }
 
+/* savetimers is a dict mapping exerciseIDs to timer IDs.
+ * Its members indicate all exercises that have been modified but not saved.
+ */
+savetimers = {}
+
+/** Changes whether an exercise is considered "saved" or not.
+ * stat is a string which specifies the status, and also the button text.
+ * If stat == "Save", then it indicates it is NOT saved. This will
+ * enable the "Save" button, and set a timer going which will auto-save
+ * after a set period of time (eg. 30 seconds).
+ * Any other value will disable the "Save" button and disable the timer.
+ * stat should be "Saving..." when the save request is issued, and "Saved"
+ * when the response comes back.
+ */
+function set_saved_status(exerciseid, filename, stat)
+{
+    var timername = "savetimer_" + exerciseid;
+    var button = document.getElementById("savebutton_" + exerciseid);
+    var is_saved = stat != "Save";
+    button.value = stat;
+
+    /* Disable the timer, if it exists */
+    if (typeof(savetimers[timername]) != "undefined")
+    {
+        clearTimeout(savetimers[timername]);
+        savetimers[timername] = undefined;
+    }
+
+    if (is_saved)
+    {
+        /* Disable the button */
+        button.disabled = true;
+    }
+    else
+    {
+        /* Enable the button */
+        button.disabled = false;
+        /* Create a timer which will auto-save when it expires */
+        var save_string = "saveexercise(" + repr(exerciseid) + ", "
+            + repr(filename) + ")"
+        savetimers[timername] = setTimeout(save_string, 10000);
+    }
+}
+
 /** Given a exercise div, return the testoutput div which is its child.
  * (The div which is its child whose class is "testoutput".
  */

